================================
QuoEdit version 0.32
================================

QuoEdit (formerly QEdit) is a simple monostyled text editor that runs on System 7 or later versions of Mac OS.
QuoEdit is also AppleScript aware. If you are not familiar with AppleScript, Apple events or terms of such things, you can skip those sections.


1  Whats New
1.1  Significant new features of version 0.31
1.1.1  Recording, running and saving sequence
You can now record your operations like keyboard macro without the Script Editor. You can also save it in a script file with QuoEdit!

1.1.2  Appearance-compliant Menu display
If Appearance Manager is installed on your computer, keyboard equivalents with the shift or option key are now displayed in the menu.
QuoEdit has the keyboard equivalents for every menu commands. Oh yes, I know that Apples guideline says Assign keyboard equivalents only for frequently used menu commands. Im sorry, but I like shortcut keys so much.

1.1.3  Cmd-Ctrl shortcut keys
You can now execute a script saved in the script file with cmd-ctrl shortcut key. About how to name the script file, see 2.5.5.

1.2  Changed from version 0.31
1.2.1  The Form scripts are recorded
QuoEdit had recorded tasks with the Script Editor in the usual form like Scriptable Text Editor does. Now, QuoEdit records in something different form so that QuoEdit now supports a feature like keyboard macro.

1.2.2  Numbering untitled documents
Formerly, QuoEdit began with untitled 1 and always increased the number. Now, begins with untitled and after all documents are closed, it begins with untitled again as Apples human interface guidelines suggest.

1.2.3  Shortcut key for Jump to command
Changed from cmd-comma to cmd-J. Cmd-comma may have different action in the future versions.

1.2.4  Separated Speak menu items
The Speak menu item of QuoEdit had had four commands sometimes with the option key  Speak, Stop Speaking, Pause Speaking and Continue Speaking. Now, <Speak/Stop> and <Pause/Continue> are separated.


2  Menus & Commands
2.1  File
2.1.1  New
If you have once used SimpleText or TeachText, these commands must be so obvious for you. In many cases, the command name itself is the description of the function.

2.1.2  Open
About the shortcut key, be careful typing cmd-O or cmd-I. And ensuring always the default buttons name is recommended.

2.1.3  Close
To close every document, hold down the option key.

2.1.4  Save
To save every document, hold down the option key.

2.1.5  Save as
The shortcut key is cmd-shift-S.

2.1.6  Revert
The shortcut key is cmd-shift-R.

2.1.7  Insert File
With the option key, any files data can be inserted (but not resources).

2.1.8  Page Setup
The shortcut key is cmd-shift-P.
To set default state, do it after closing all windows.

2.1.9  Print Options
The shortcut key is cmd-option-P.

2.1.10  Print

2.1.11  Quit

2.2  Edit
2.2.1  Undo
Up to 10 levels of undo/redo are available for each document. The max levels can be specified at Misc Appl Props dialog box. Note that the more levels, the more memory used.

2.2.2  Redo
The shortcut key is cmd-shift-Z.

2.2.3  Cut

2.2.4  Copy

2.2.5  Paste

2.2.6  Clear

2.2.7  Select All

2.2.8  View
Items of View dialog box just effect view on the display. For example, though document windows can be inverted or meshed, results of printing documents are always normal. Moreover, showing return characters does not effect whether or not to print them.

2.2.9  Typeface
As the minimum value of the leading (line height), it can be same as the value of the font size but note that lines can be displayed improperly with too small leading.

2.2.10  Misc Appl Props (Miscellaneous Application Properties)
2.2.10.1  Auto Indent

2.2.10.2  Remember & Resume Selection
Turning on this option, the selected location of each document at the last saved time (not closed time) is to be remembered.

2.2.10.3  Styled Output
Option to pass the selected text as a styled text when copy, cut or dragging out is done. It will be useful for foreign languages whose script is different from the system script.

2.2.10.4  TSM aware
If your input method has problems on inline input, try turning off this option. Inline input is an input mode of input method for 2-byte languages (Japanese, Chinese and Korean).
All TSM (Text Services Manager) service that QuoEdit currently supports is inline input.

2.2.10.5  Caret Speed
Try it if you are not satisfied with the top speed of the Keyboard control panel. But there will be no effect with old CPU. In that case, select normal (1) speed.

2.2.10.6  Undo Levels
Currently 1-10.

2.3  Search
2.3.1  Find

2.3.2  Find Backward Again

2.3.3  Find Forward Again
Hold down the shift key if you wish to extend selection range from current location. This is also applied to other commands.
Hold down the option key if you wish not to select the target string. This is also applied to other search commands.

2.3.4  Enter Selection
Enters current selection to the Search for string. Adding the option key, it enters the selection to the Replace with string.

2.3.5  Replace

2.3.6  Replace & Find Next

2.3.7  Replace All

2.3.8  Jump To

2.4  Windows
2.4.1  Window Size
Specifying -1 in the dialog box, especially for the height, has the special meaning.

2.4.2  Zoom

2.4.3  First Position
The position for new windows can be defined to avoid jam at the upper left area of the monitor.

2.4.4  Arrange
Rearranges windows according to the information set with the First Position dialog box. Not only windows but it also rearranges shortcut keys in the Windows menu items.
With the option key, stacked up, with the shift keys, stacked down.

2.5  Options
2.5.1  Last Script
Repeats the last script executed via the Execute Script command.
The shortcut key is cmd-shift-U.

2.5.2  Execute Script
Executes script in Scripts folder in QuoEdits folder (or other folders). Of course you can write your own scripts and put them into the folder.
It requires AppleScript installed on the computer.

With the option key, it makes the Finder open the file if the Finder is scriptable(*). Other commands which use the standard file dialog box (Open, Insert File) allow you to do the similar thing.

(*) About System 7.5 or later, no problem. About System 7.1, Finder version 7.1 is not scriptable but Finder version 7.1.3 and Finder Scripting Extension make it scriptable.

2.5.3  Record Sequence
Records your operations as a script.
The shortcut key is cmd-option-B. The "B" is from keyBoard macro but to be exact, it is not keyboard macro because it entirely depends on the Open Scripting Architecture.

Note that QuoEdit now records keyboard actions as the relative movements while mouse clickings are recorded with the absolute locations.

About controls on the dialog boxes, only the results are recorded.

2.5.4  Run Sequence
Replays the recorded operations as a script.

2.5.5  Save Sequence
Saves the recorded operations in a script file.
The shortcut key is cmd-shift-B.

If you are going to execute it frequently for a while, save it in the default folder with name of the following form;
	~a	~b	~8	~3		etc.
You can execute script of such name in the Scripts folder by cmd-ctrl shortcut key. For example, you can execute s script named ~e with cmd-ctrl-E.
This can be applied to other script files. For example, try making an alias of frequently used script file with the name of the form.
(I would like to prepare the table for cmd-ctrl shortcut keys that can be customized in the future.)

Well, now you can treat scripts without the Script Editor but it will benefit you to understand how the operatins are recorded. If you wish to read or edit the script immediately, hold down the option key when you press the Save button.

2.5.6  Launch Applications
Makes switching to other application in Applications folder in QuoEdits folder (or other folders) possible. Put files like scripts saved as applications or applications aliases into the folder as you like.

2.5.7  Speak / Stop Speaking
If Speech Manager is installed on your computer, this command is enabled and QuoEdit can make your computer speak. But only languages Speech Manager supports.
Since QuoEdit passes a copy of text to the Speech Manager just once, you can freely edit the text while computer is speaking.

2.5.8  Pause Speaking / Continue Speaking
The shortcut key is cmd-option-K.


3  Miscellaneous
3.1  Data size
Document data size that QuoEdit can edit depends mainly on the computers available memory. (formerly, only on the applications memory)

3.2  Arrow key movement
As Apples human interface guidelines suggest, the option key increases the unit of movement and the command key increases it again.

3.3  Shortcuts guide
If Apple Guide is installed on your computer and QE Shortcuts file is in the QuoEdits folder, you can see about shortcuts from the Help (guide) menu.

3.4  Properties of each document
Items of every dialog box which has the Set Default button are properties of each document and they are saved in each document file (made by QuoEdit) as a resource. For example, whether or not to print return characters specified in the Print Options dialog box is a property of each document. (Printing special characters will be useful just for the document to be proofed.)

Print information set in the Page Setup dialog box is also a property of each document but whether or not to save the information (120 bytes) in the file can be selected in the Print Options dialog box. (Versions 0.1.x and 0.2.x always saved it.)

3.5  Drag and drop
Drag and drop can be done on the document windows or the Find dialog box. Receiving text files is also available.
(If you are a System 7.0 or 7.1 user, you have to get and install softwares which enable the Macintosh Drag and Drop to take advantage of it.)

3.6  Right-to-left direction language
If the script system containing WorldScript I is installed on your computer, you can edit text of right-to-left direction language like Arabic or Hebrew with QuoEdit on condition that the contents are not bidirectional, for example, that Hebrew context contains no English words.
If the system direction is right-to-left, editing bidirectional text will be fine except that selection range on the display is always contiguous.
Currently, QuoEdit fixes the line alignment of Hebrew or Arabic font documents to right regardless of the system direction.

3.7  The color
Take it easy, please, if you found that, someday, the color of status bar changes day by day. Its just a feature of QuoEdit. The beginning is the April Fools Day.

3.8  Whats quo?
  q:	quick manipulations (my wish)
  u:	understandable simple user interface (a little forced wish)
  o:	OSA (Open Scripting Architecture) aware

About Latin word quo, you may want to ask your evangelist.


4  Topics of AppleScript / Apple Events
4.1  AppleScript aware
AppleScript is a very useful stuff that makes various tasks automated and QuoEdit is AppleScript aware  scriptable and recordable about almost every task other than drag and drop with tools like the Script Editor.
(About AppleScript itself, it is not described here. Please refer to books or documents about AppleScript if you feel necessary.)

By the way, AppleScript is one of the scripting components that support Open Scripting Architecuture (OSA) of Apple Computer. So, you should understand AppleScript in this document as AppleScript or other scripting component. Actually, I have not seen other scripting component so that QuoEdit was tested only with AppleScript.

4.2  Confusing words
4.2.1  Command or Event?
About command of AppleScript, it is described as event in this document from view point of Apple event to distinguish it from applications menu command.

4.2.2  Script?
We will find out two meanings in the word script in the Mac OS softwares.
First, a generic term of languages. For example, Roman script contains English language, German language etc. and Japanese script contains only Japanese language. Of course we dont talk about it here.
Second, executable program or the source text of the program that can be written by the users. Especially, here it means script in the AppleScript form.
So dont be confused about the word script. You will be able to distinguish them in the context.

4.3  Terms
To refer for events and classes that QuoEdit supports, do the Open Dictionary command of the Script Editor and choose QuoEdit. You can also do it by just dragging QuoEdits icon to the Script Editors icon.
If you often do it, try the following script.

tell application "Finder" to open file (path to application "QuoEdit") 
	using path to application "Script Editor"

4.4  A restriction of AppleScript
I learned that the maximum text length AppleScript can treat is 30000 bytes. (That is described on some Apples document but forgot what document it was.)
But if QuoEdit and AppleScript dont send text each other, the restriction does not matter.

For example, when you select a large text and let AppleScript do a script that contains the following statement, a system error can actually occur.
	if selection as text is not "" then
To avoid the problem, replace it with the following.
	if 0 < length of selection then

4.5  Transliterate
When this event is sent to QuoEdit, It just passes a translation of the order to a Mac OS toolbox routine called TransliterateText and replace the specified original text with the result text.
Currently, the results of 1-byte <--> 2-byte conversion for Asian languages are not perfect and it may be problem of resources that TransliterateText routine uses. About this issue, please ask Apple Computer.
About the max text length that TransliterateText routine can treat, it seems to be 65535 bytes that is the max 2-byte integer. (I got the value from my experiments.)

4.6  Cut/copy/paste
Before letting QuoEdit do these things by script, activate QuoEdit if not active because cut, copy or paste at background can be failed. Note that QuoEdit explicitly avoids error message about this issue.

4.7  Do copy
From version 0.31, QuoEdit has ignoring selection error parameter (which ignores no-user-selection error) for cut and copy events optionally but AppleScript (version 1.1) will not accept the parameter for copy. (About cut, its OK.) In that case, try do copy which is just a dummy name of copy to fool the AppleScript.

AppleScript may try interpreting copy something different way from other events because copy is a standard command of AppleScript while it is also event name many applications support. When cut is OK but copy is not, try do copy.

4.8  Ignoring selection error parameter for copy/cut events
When operations are recorded, QuoEdit uses this parameter for copy and cut events. If you treat tab delimited records and some fields are empty for example, you will realize how its useful.

4.9  Definite index for some class objects
About file class that belongs to document class, only 1 is available as the index like this:
	file 1 of document "Things To Do!" of application "QuoEdit"

About script class that belongs to application class, only -1, 1, last or first are available as the index.
-1 or last means the last executed script via Execute Script command:
	last script of application "QuoEdit"
1 or first means the currently recorded operations sequence as a script:
	script 1 of application "QuoEdit"

5  Environment
This version of QuoEdit was developed and tested mainly or only on the following environment.

	Computer: Macintosh LC475
				(tuned to 33MHz with FPU; tuning not recommended)
	OS: Mac System 7.5.1, 7.1, OS 7.6.1, 8 (and several Language Kits)
	Development tools:
			Symantec C++ version 7.0 (C language)
			Guide Maker 1.4b3
	Printer: PC-PR1000EW, NEC
	Printer driver: MacPrint Pages ver.1.0.1, Kansai Electric


6  Distribution
QuoEdit 0.31 is a freeware. You can distribute it to your friends.
QuoEdit is copyrighted and all rights to it are reserved by the author Lyomei Sakai.
Scripts in Scripts folder are also copyrighted but I will not insist on them. You may, I think, use those scripts on your responsibility.
I will not take responsibility for results of using QuoEdit. But I will appreciate your bug reports or advices.


7  Acknowledgements
Thanks to people who gave me nice messages! And many thanks to people who gave me informations or great advices for improvement of QuoEdit!



Mar, 1998
Lyomei Sakai in Osaka, Japan
E-mail: NDA02214@biglobe.ne.jp  /  HZI02445@niftyserve.or.jp

(SSC01348@niftyserve.or.jp is obsolete from April 1, 1998.)
